<script setup lang="ts">
import { ref } from 'vue'

import DialogEdit from '../Member/DialogEdit.vue';


import { useMemberStore } from '@/stores/member'
import { useReceiptStore } from '@/stores/receipt'

import type { Member } from '@/types/Member';
const tel = ref('')
const memberStore = useMemberStore()
const receiptStore = useReceiptStore()
const point = ref(0)
const disMember = ref(0)
const dialogMember = ref(false)
const initilMember: Member = {
  id: -1,
  name: '',
  tel: '',
  point: 0
}
const editedMember = ref<Member>(JSON.parse(JSON.stringify(initilMember)))
function onClick() {
  memberStore.searchMember(tel.value)
  receiptStore.calReceipt()
  setTel()
  askDiscountMember()
}
function usePoint() {
  disMember.value = Math.floor(point.value / 10)
  receiptStore.setDisMember(disMember.value)
  memberStore.usePoint()
  dialogMember.value = false

}
function askDiscountMember() {
  receiptStore.setDisMember(0)
  if (memberStore.currentMember != null && memberStore.currentMember != undefined) {
    point.value = memberStore.currentMember.point
    if (point.value >= 10) {
      dialogMember.value = true
    }
  }

}
const setTel = () => {
  tel.value = ''
}
function OnInput() {
  tel.value = tel.value.replace(/[^0-9]/g, '')
  editedMember.value.tel = editedMember.value.tel.replace(/[^0-9]/g, '')
}
</script>

<template>
  <v-container>
    <v-row align="center">
      <v-col cols="3">
        <v-text-field 
        v-model="tel" 
        density="compact" 
        variant="solo" 
        label="Search Member" 
        append-inner-icon="mdi-magnify"
        hide-details 
        @click:append-inner="onClick" 
        @keyup.enter="onClick" 
        inputmode="numeric"
        pattern="[0-9]*" 
        @input="OnInput">
        
        </v-text-field>
    </v-col>
    <v-col cols="2" class="pa-0">
    <v-btn prepend-icon="mdi-account-plus" color="brown-lighten-1" elevation="8" block @click="memberStore.openDialog()"><label style="font-size:12px;">Add Member</label></v-btn>
  </v-col>  
      <v-col cols="4" class="pa-2"
        >Member: {{ memberStore.currentMember ? memberStore.currentMember?.name : '-' }}</v-col
      >
      <v-divider :thickness="2" class="border-opacity-100" vertical></v-divider>
      <v-col cols="2" class="pa-2">Point: {{ memberStore.currentMember ? memberStore.currentMember?.point : '-' }}</v-col>
    </v-row>
  </v-container>
  <!--dialog ask Point member-->
  <v-dialog v-model="dialogMember" persistent width="auto">
    <v-card>
      <v-card-title class="text-h5">
        แต้มสมาชิก
      </v-card-title>
      <v-card-text>คุณลูกค้ามี point ทั้งหมด {{ point }} point สามารถแลกได้ {{ Math.floor(point / 10) }} บาท</v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="green-darken-1" variant="text" @click="dialogMember = false">
          ไม่ใช้แต้ม
        </v-btn>
        <v-btn color="green-darken-1" variant="text" @click="usePoint()">
          ใช้แต้ม
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
  <DialogEdit></DialogEdit>
</template>
